# Flutter Shortcuts

<img src="https://i.imgur.com/462Y6wf.gif" title="source: imgur.com" />

![GitHub](https://img.shields.io/github/license/divshekhar/flutter_shortcuts?style=plastic) ![GitHub code size in bytes](https://img.shields.io/github/languages/code-size/divshekhar/flutter_shortcuts?style=plastic) ![GitHub top language](https://img.shields.io/github/languages/top/divshekhar/flutter_shortcuts?style=plastic) ![GitHub language count](https://img.shields.io/github/languages/count/divshekhar/flutter_shortcuts?style=plastic) ![GitHub tag (latest by date)](https://img.shields.io/github/v/tag/divshekhar/flutter_shortcuts?style=plastic)

## Show some :heart: and :star: the repo

[![GitHub followers](https://img.shields.io/github/followers/divshekhar.svg?style=social&label=Follow)](https://github.com/divshekhar/)

## Demo

<img src="https://i.imgur.com/BXQJXmW.gif"/>

## Quick Start

### Step 1: Include plugin to your project

```yml
dependencies:
  flutter_shortcuts: <latest version>
```

Run pub get and get packages.

### Step 2: Instantiate Flutter Shortcuts Plugin

```dart
final FlutterShortcuts flutterShortcuts = FlutterShortcuts();
```

### Step 3: Initialize Flutter Shortcuts

```dart
flutterShortcuts.initialize((String incomingAction) {
    setState(() {
    if (incomingAction != null) {
        action = incomingAction;
    }
  });
});
```

## Arguments

There are several function that allow for more control:

|  Properties  |   Description   |
|--------------|-----------------|
| `initialize` | performs action when shortcut is initiated.| 
| `getMaxShortcutLimit` | returns the maximum number of static or dynamic shortcuts that each launcher icon can have at a time. |
| `setShortcutItems` | will set all the shortcut items. |
| `clearShortcutItems` | will remove all the shortcut items.|
| `pushShortcutItem` | will push a new shortcut item.If there is already a dynamic or pinned shortcut with the same **ID**, the shortcut will be updated and pushed at the end of the shortcut list. |
| `addShortcutItems` |updates dynamic or pinned shortcuts with same IDs and pushes new shortcuts with different IDs. |
| `updateShortcutItems` | updates shortcut items. If the IDs of the shortcuts are not same, no changes will be reflected. |
| `updateShortcutItem` | updates a single shortcut item based on id. If the ID of the shortcut is not same, no changes will be reflected. |
| `changeShortcutItemIcon` | will change the icon of the shortcut based on id.s If the ID of the shortcut is not same, no changes will be reflected. |

## Project Created & Maintained By

### Divyanshu Shekhar

<a href="https://twitter.com/dshekhar17"><img src="https://github.com/aritraroy/social-icons/blob/master/twitter-icon.png?raw=true" width="60"></a> <a href="https://in.linkedin.com/in/divyanshu-shekhar-a8a04a162"><img src="https://github.com/aritraroy/social-icons/blob/master/linkedin-icon.png?raw=true" width="60"></a> <a href="https://instagram.com/dshekhar17"><img src="https://github.com/aritraroy/social-icons/blob/master/instagram-icon.png?raw=true" width="60"></a>

### Subham Praharaj

<a href="https://twitter.com/SubhamPraharaj6"><img src="https://github.com/aritraroy/social-icons/blob/master/twitter-icon.png?raw=true" width="60"></a> <a href="https://www.linkedin.com/in/subham-praharaj-66b172179/"><img src="https://github.com/aritraroy/social-icons/blob/master/linkedin-icon.png?raw=true" width="60"></a> <a href="https://instagram.com/the_champ_subham_865"><img src="https://github.com/aritraroy/social-icons/blob/master/instagram-icon.png?raw=true" width="60"></a>

## Copyright & License

Code and documentation Copyright (c) 2021 [Divyanshu Shekhar](https://divyanshushekhar.com). Code released under the [BSD 3-Clause License](./LICENSE).